#!/usr/bin/ruby -w

# run using:
# ./create_users.rb

require 'equitrac/connection'
require 'equitrac/utilities'
require 'yaml'

# CONNECTION #
##########
srv_file   = 'connection-sample.yml' if File.file?('connection-sample.yml')
srv_file   = 'connection.yml'        if File.file?('connection.yml') # real
srv_file ||= nil
#
srv_info   = nil
begin
  srv_info = YAML.load_file(srv_file)
rescue ArgumentError => e
  puts "YAML Error: #{e.message}"
end                                    unless srv_file.nil?
srv_info    = YAML.load_file(srv_file) unless srv_file.nil?
srv_info  ||= { hostname: 'equitrac.example.com', # remote server hostname
                username: 'remote',               # remote login username
                eq_service: 'eq56',               # equitrac SERVICE name
              }
# File.write("connection-sample.yml",srv_info.to_yaml)
puts "\nSRV_INFO: #{srv_info}"

server  = Equitrac::Connection.new( srv_info[:hostname],
                                srv_info[:username],
                                srv_info[:eq_service]
                              )        unless srv_info.nil?
# USERS #
#########
users_file = 'users-sample.yml'            if File.file?('users-sample.yml')
users_file = 'users.yml'                   if File.file?('users.yml') # real
users_file ||= nil
#
users = nil
begin
  users  = YAML.load( File.open(users_file) )
rescue ArgumentError => e
  puts "YAML Error: #{e.message}"
end                                    unless users_file.nil?
# srv_info   = YAML.load_file(users_file) unless users_file.nil?
# users ||= [
#             { primary_pin: 12345,
#               user_id: "username1",
#               email: "username1@examle.com",
#               user_name: "FirstName1 LastName1",
#               dept_name: 'employee',
#             }
#           ]
# File.write("users-sample.yml",users.to_yaml)
puts "\nUSERS:"
pp users

# add is this what you expect?
puts "Review the user data \nEnter 'Y' to create eq56 accounts"
answer = gets.chomp.downcase
puts "aborting account creation"  unless answer.eql? 'y'
exit                              unless answer.eql? 'y'
puts "creating eq56 accounts ..."

# CREATE #
##########
puts "\nEQ56 Commands:"
users.each do |person|
  person[:init_bal] = 50.0
  cmd = Equitrac::Utilities::User.add( person )
  puts cmd
  puts server.execute(cmd)
end                                    unless users.nil?
